/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ************************************************************************
 * \file quant.h
 *
 * \brief
 *    definitions for quantization functions
 *
 * \author
 *
 ************************************************************************
 */

#ifndef _QUANT_H_
#define _QUANT_H_

// Macro defines
#define Q_BITS          15
#define DQ_BITS          6
#define Q_BITS_8        16
#define DQ_BITS_8        6 

// exported variables
extern const int dequant_coef[6][4][4];
extern const int quant_coef[6][4][4];

extern int InvLevelScale4x4_Intra[3][6][4][4];
extern int InvLevelScale4x4_Inter[3][6][4][4];
extern int InvLevelScale8x8_Intra[3][6][8][8];
extern int InvLevelScale8x8_Inter[3][6][8][8];

extern int *qmatrix[12];

// SP decoding parameter (EQ. 8-425)
extern const int A[4][4];

extern int *qp_per_matrix;
extern int *qp_rem_matrix;

// exported functions
// quantization initialization
void init_qp_process(ImageParameters *img);

// For Q-matrix
void AssignQuantParam(pic_parameter_set_rbsp_t* pps, seq_parameter_set_rbsp_t* sps);
void CalculateQuantParam(void);
void CalculateQuant8Param(void);

#endif

