/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 *************************************************************************************
 * \file mb_access.h
 *
 * \brief
 *    Functions for macroblock neighborhoods
 *
 * \author
 *     Main contributors (see contributors.h for copyright, address and affiliation details)
 *     - Karsten Shring                 <suehring@hhi.de> 
 *     - Alexis Michael Tourapis         <alexismt@ieee.org>  
 *************************************************************************************
 */

#ifndef _MB_ACCESS_H_
#define _MB_ACCESS_H_

void CheckAvailabilityOfNeighbors(Macroblock *currMB);

void (*getNeighbour)         (Macroblock *currMb, int xN, int yN, int mb_size[2], PixelPos *pix);
void getAffNeighbour         (Macroblock *currMb, int xN, int yN, int mb_size[2], PixelPos *pix);
void getNonAffNeighbour      (Macroblock *currMb, int xN, int yN, int mb_size[2], PixelPos *pix);
void get4x4Neighbour         (Macroblock *currMb, int xN, int yN, int mb_size[2], PixelPos *pix);
int  mb_is_available         (int mbAddr, Macroblock *currMb);
void get_mb_pos              (int mb_addr, int mb_size[2], int *x, int*y);
void (*get_mb_block_pos)     (int mb_addr, int *x, int*y);
void get_mb_block_pos_normal (int mb_addr, int *x, int*y);
void get_mb_block_pos_mbaff  (int mb_addr, int *x, int*y);


#endif
