/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ************************************************************************
 * \file
 *     me_fullsearch.h
 *
 * \author
 *    Alexis Michael Tourapis        <alexis.tourapis@dolby.com>
 *
 * \date
 *    9 September 2006
 *
 * \brief
 *    Headerfile for Full Search motion estimation
 **************************************************************************
 */


#ifndef _ME_FULLSEARCH_H_
#define _ME_FULLSEARCH_H_
extern int FullPelBlockMotionSearch (Macroblock *currMB, imgpel* orig_pic, short ref, int list, int list_offset, 
                                     char ***refPic, short ****tmp_mv, int pic_pix_x, int pic_pix_y,
                                     int blocktype, short pred_mv[2], short mv[2], 
                                     int search_range,  int min_mcost, int lambda_factor, int apply_weights);
extern int FullPelBlockMotionBiPred (Macroblock *currMB, imgpel* orig_pic, short ref, int list, int list_offset, 
                                     char ***refPic, short ****tmp_mv, int pic_pix_x, int pic_pix_y,
                                     int blocktype, short pred_mv1[2], short pred_mv2[2], short mv1[2], short mv2[2],
                                     int search_range, int min_mcost, int iteration_no, int lambda_factor, int apply_weights);
extern int SubPelBlockMotionSearch  (imgpel* orig_pic, short ref, int list, int list_offset, int pic_pix_x, int pic_pix_y,
                                     int blocktype, short pred_mv[2], short mv[2],
                                     int search_pos2, int search_pos4, int min_mcost, int* lambda_factor, int apply_weights);
extern int SubPelBlockSearchBiPred  (imgpel* orig_pic, short ref, int list, int pic_pix_x, int pic_pix_y,
                                     int blocktype, short pred_mv1[2], short pred_mv2[2], short mv1[2], short mv2[2], 
                                     int search_pos2, int search_pos4, int min_mcost, int* lambda_factor, int apply_weights);

#endif

