/**********************************************************************
 * Software Copyright Licensing Disclaimer
 *
 * This software module was originally developed by contributors to the
 * course of the development of ISO/IEC 14496-10 for reference purposes
 * and its performance may not have been optimized.  This software
 * module is an implementation of one or more tools as specified by
 * ISO/IEC 14496-10.  ISO/IEC gives users free license to this software
 * module or modifications thereof. Those intending to use this software
 * module in products are advised that its use may infringe existing
 * patents.  ISO/IEC have no liability for use of this software module
 * or modifications thereof.  The original contributors retain full
 * rights to modify and use the code for their own purposes, and to
 * assign or donate the code to third-parties.
 *
 * This copyright notice must be included in all copies or derivative
 * works.  Copyright (c) ISO/IEC 2004, 2005, 2006, 2007, 2008.
 **********************************************************************/

/*!
 ***************************************************************************
 *
 * \file transform.h
 *
 * \brief
 *    prototypes of transform functions
 *
 * \date
 *    10 July 2007
 *
 * \author
 *    Main contributors (see contributors.h for copyright, address and affiliation details)
 *    Alexis Michael Tourapis
 **************************************************************************/

#ifndef _TRANSFORM_H_
#define _TRANSFORM_H_

void forward4x4   (int (*block) [16], int (*tblock)[16], int pos_y, int pos_x);
void inverse4x4   (int (*tblock)[16], int (*block )[16], int pos_y, int pos_x);
void forward8x8   (int (*block) [16], int (*tblock)[16], int pos_y, int pos_x);
void inverse8x8   (int (*tblock)[16], int (*block )[16], int pos_y, int pos_x);
void hadamard4x4  (int (*block) [ 4], int (*tblock)[ 4]);
void ihadamard4x4 (int (*tblock)[ 4], int (*block) [ 4]);
void hadamard4x2  (int (*block) [ 4], int (*tblock)[ 4]);
void ihadamard4x2 (int (*tblock)[ 4], int (*block) [ 4]);
void hadamard2x2  (int (*block)[16], int tblock[4]);
void ihadamard2x2 (int block[4], int tblock[4]);

#endif //_TRANSFORM_H_
